]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Make the emacsclient binary user-configurable
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # if --tee was passed, write the output not only to the terminal, but
26 # additionally to the file test-results/$BASENAME.out, too.
27 case "$GIT_TEST_TEE_STARTED, $* " in
28 done,*)
29         # do not redirect again
30         ;;
31 *' --tee '*|*' --va'*)
32         mkdir -p test-results
33         BASE=test-results/$(basename "$0" .sh)
34         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
35          echo $? > $BASE.exit) | tee $BASE.out
36         test "$(cat $BASE.exit)" = 0
37         exit
38         ;;
39 esac
40
41 # Keep the original TERM for say_color and test_emacs
42 ORIGINAL_TERM=$TERM
43
44 # For repeatability, reset the environment to known value.
45 LANG=C
46 LC_ALL=C
47 PAGER=cat
48 TZ=UTC
49 TERM=dumb
50 export LANG LC_ALL PAGER TERM TZ
51 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
52 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
53       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
54     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
55     exit 1
56 fi
57 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
58 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
59
60 # Protect ourselves from common misconfiguration to export
61 # CDPATH into the environment
62 unset CDPATH
63
64 unset GREP_OPTIONS
65
66 # Convenience
67 #
68 # A regexp to match 5 and 40 hexdigits
69 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
70 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
71
72 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
73 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
74
75 # Each test should start with something like this, after copyright notices:
76 #
77 # test_description='Description of this test...
78 # This test checks if command xyzzy does the right thing...
79 # '
80 # . ./test-lib.sh
81 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
82                 TERM=$ORIGINAL_TERM &&
83                 export TERM &&
84                 [ -t 1 ] &&
85                 tput bold >/dev/null 2>&1 &&
86                 tput setaf 1 >/dev/null 2>&1 &&
87                 tput sgr0 >/dev/null 2>&1
88         ) &&
89         color=t
90
91 while test "$#" -ne 0
92 do
93         case "$1" in
94         -d|--d|--de|--deb|--debu|--debug)
95                 debug=t; shift ;;
96         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
97                 immediate=t; shift ;;
98         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
99                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
100         -h|--h|--he|--hel|--help)
101                 help=t; shift ;;
102         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
103                 verbose=t; shift ;;
104         -q|--q|--qu|--qui|--quie|--quiet)
105                 quiet=t; shift ;;
106         --with-dashes)
107                 with_dashes=t; shift ;;
108         --no-color)
109                 color=; shift ;;
110         --no-python)
111                 # noop now...
112                 shift ;;
113         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
114                 valgrind=t; verbose=t; shift ;;
115         --tee)
116                 shift ;; # was handled already
117         --root=*)
118                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
119                 shift ;;
120         *)
121                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
122         esac
123 done
124
125 if test -n "$debug"; then
126     print_subtest () {
127         printf " %-4s" "[$((test_count - 1))]"
128     }
129 else
130     print_subtest () {
131         true
132     }
133 fi
134
135 if test -n "$color"; then
136         say_color () {
137                 (
138                 TERM=$ORIGINAL_TERM
139                 export TERM
140                 case "$1" in
141                         error) tput bold; tput setaf 1;; # bold red
142                         skip)  tput bold; tput setaf 2;; # bold green
143                         pass)  tput setaf 2;;            # green
144                         info)  tput setaf 3;;            # brown
145                         *) test -n "$quiet" && return;;
146                 esac
147                 shift
148                 printf " "
149                 printf "$@"
150                 tput sgr0
151                 print_subtest
152                 )
153         }
154 else
155         say_color() {
156                 test -z "$1" && test -n "$quiet" && return
157                 shift
158                 printf " "
159                 printf "$@"
160                 print_subtest
161         }
162 fi
163
164 error () {
165         say_color error "error: $*\n"
166         GIT_EXIT_OK=t
167         exit 1
168 }
169
170 say () {
171         say_color info "$*"
172 }
173
174 test "${test_description}" != "" ||
175 error "Test script did not set test_description."
176
177 if test "$help" = "t"
178 then
179         echo "Tests ${test_description}"
180         exit 0
181 fi
182
183 echo $(basename "$0"): "Testing ${test_description}"
184
185 exec 5>&1
186
187 test_failure=0
188 test_count=0
189 test_fixed=0
190 test_broken=0
191 test_success=0
192
193 die () {
194         code=$?
195         rm -rf "$TEST_TMPDIR"
196         if test -n "$GIT_EXIT_OK"
197         then
198                 exit $code
199         else
200                 echo >&5 "FATAL: Unexpected exit with code $code"
201                 exit 1
202         fi
203 }
204
205 GIT_EXIT_OK=
206 # Note: TEST_TMPDIR *NOT* exported!
207 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
208 trap 'die' EXIT
209
210 test_decode_color () {
211         sed     -e 's/.\[1m/<WHITE>/g' \
212                 -e 's/.\[31m/<RED>/g' \
213                 -e 's/.\[32m/<GREEN>/g' \
214                 -e 's/.\[33m/<YELLOW>/g' \
215                 -e 's/.\[34m/<BLUE>/g' \
216                 -e 's/.\[35m/<MAGENTA>/g' \
217                 -e 's/.\[36m/<CYAN>/g' \
218                 -e 's/.\[m/<RESET>/g'
219 }
220
221 q_to_nul () {
222         perl -pe 'y/Q/\000/'
223 }
224
225 q_to_cr () {
226         tr Q '\015'
227 }
228
229 append_cr () {
230         sed -e 's/$/Q/' | tr Q '\015'
231 }
232
233 remove_cr () {
234         tr '\015' Q | sed -e 's/Q$//'
235 }
236
237 # Generate a new message in the mail directory, with a unique message
238 # ID and subject. The message is not added to the index.
239 #
240 # After this function returns, the filename of the generated message
241 # is available as $gen_msg_filename and the message ID is available as
242 # $gen_msg_id .
243 #
244 # This function supports named parameters with the bash syntax for
245 # assigning a value to an associative array ([name]=value). The
246 # supported parameters are:
247 #
248 #  [dir]=directory/of/choice
249 #
250 #       Generate the message in directory 'directory/of/choice' within
251 #       the mail store. The directory will be created if necessary.
252 #
253 #  [filename]=name
254 #
255 #       Store the message in file 'name'. The default is to store it
256 #       in 'msg-<count>', where <count> is three-digit number of the
257 #       message.
258 #
259 #  [body]=text
260 #
261 #       Text to use as the body of the email message
262 #
263 #  '[from]="Some User <user@example.com>"'
264 #  '[to]="Some User <user@example.com>"'
265 #  '[subject]="Subject of email message"'
266 #  '[date]="RFC 822 Date"'
267 #
268 #       Values for email headers. If not provided, default values will
269 #       be generated instead.
270 #
271 #  '[cc]="Some User <user@example.com>"'
272 #  [reply-to]=some-address
273 #  [in-reply-to]=<message-id>
274 #  [references]=<message-id>
275 #  [content-type]=content-type-specification
276 #  '[header]=full header line, including keyword'
277 #
278 #       Additional values for email headers. If these are not provided
279 #       then the relevant headers will simply not appear in the
280 #       message.
281 #
282 #  '[id]=message-id'
283 #
284 #       Controls the message-id of the created message.
285 gen_msg_cnt=0
286 gen_msg_filename=""
287 gen_msg_id=""
288 generate_message ()
289 {
290     # This is our (bash-specific) magic for doing named parameters
291     local -A template="($@)"
292     local additional_headers
293
294     gen_msg_cnt=$((gen_msg_cnt + 1))
295     if [ -z "${template[filename]}" ]; then
296         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
297     else
298         gen_msg_name=${template[filename]}
299     fi
300
301     if [ -z "${template[id]}" ]; then
302         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
303     else
304         gen_msg_id="${template[id]}"
305     fi
306
307     if [ -z "${template[dir]}" ]; then
308         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
309     else
310         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
311         mkdir -p "$(dirname "$gen_msg_filename")"
312     fi
313
314     if [ -z "${template[body]}" ]; then
315         template[body]="This is just a test message (#${gen_msg_cnt})"
316     fi
317
318     if [ -z "${template[from]}" ]; then
319         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
320     fi
321
322     if [ -z "${template[to]}" ]; then
323         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
324     fi
325
326     if [ -z "${template[subject]}" ]; then
327         if [ -n "$test_subtest_name" ]; then
328             template[subject]="$test_subtest_name"
329         else
330             template[subject]="Test message #${gen_msg_cnt}"
331         fi
332     fi
333
334     if [ -z "${template[date]}" ]; then
335         template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
336     fi
337
338     additional_headers=""
339     if [ ! -z "${template[header]}" ]; then
340         additional_headers="${template[header]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[reply-to]}" ]; then
345         additional_headers="Reply-To: ${template[reply-to]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[in-reply-to]}" ]; then
350         additional_headers="In-Reply-To: ${template[in-reply-to]}
351 ${additional_headers}"
352     fi
353
354     if [ ! -z "${template[cc]}" ]; then
355         additional_headers="Cc: ${template[cc]}
356 ${additional_headers}"
357     fi
358
359     if [ ! -z "${template[bcc]}" ]; then
360         additional_headers="Bcc: ${template[bcc]}
361 ${additional_headers}"
362     fi
363
364     if [ ! -z "${template[references]}" ]; then
365         additional_headers="References: ${template[references]}
366 ${additional_headers}"
367     fi
368
369     if [ ! -z "${template[content-type]}" ]; then
370         additional_headers="Content-Type: ${template[content-type]}
371 ${additional_headers}"
372     fi
373
374     if [ ! -z "${template[content-transfer-encoding]}" ]; then
375         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
376 ${additional_headers}"
377     fi
378
379     # Note that in the way we're setting it above and using it below,
380     # `additional_headers' will also serve as the header / body separator
381     # (empty line in between).
382
383     cat <<EOF >"$gen_msg_filename"
384 From: ${template[from]}
385 To: ${template[to]}
386 Message-Id: <${gen_msg_id}>
387 Subject: ${template[subject]}
388 Date: ${template[date]}
389 ${additional_headers}
390 ${template[body]}
391 EOF
392 }
393
394 # Generate a new message and add it to the database.
395 #
396 # All of the arguments and return values supported by generate_message
397 # are also supported here, so see that function for details.
398 add_message ()
399 {
400     generate_message "$@" &&
401     notmuch new > /dev/null
402 }
403
404 # Deliver a message with emacs and add it to the database
405 #
406 # Uses emacs to generate and deliver a message to the mail store.
407 # Accepts arbitrary extra emacs/elisp functions to modify the message
408 # before sending, which is useful to doing things like attaching files
409 # to the message and encrypting/signing.
410 emacs_deliver_message ()
411 {
412     local subject="$1"
413     local body="$2"
414     shift 2
415     # before we can send a message, we have to prepare the FCC maildir
416     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
417     # eval'ing smtp-dummy --background will set smtp_dummy_pid
418     smtp_dummy_pid=
419     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
420     test -n "$smtp_dummy_pid" || return 1
421
422     test_emacs \
423         "(let ((message-send-mail-function 'message-smtpmail-send-it)
424                (smtpmail-smtp-server \"localhost\")
425                (smtpmail-smtp-service \"25025\"))
426            (notmuch-hello)
427            (notmuch-mua-mail)
428            (message-goto-to)
429            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
430            (message-goto-subject)
431            (insert \"${subject}\")
432            (message-goto-body)
433            (insert \"${body}\")
434            $@
435            (message-send-and-exit))"
436
437     # In case message was sent properly, client waits for confirmation
438     # before exiting and resuming control here; therefore making sure
439     # that server exits by sending (KILL) signal to it is safe.
440     kill -9 $smtp_dummy_pid
441     notmuch new >/dev/null
442 }
443
444 # Generate a corpus of email and add it to the database.
445 #
446 # This corpus is fixed, (it happens to be 50 messages from early in
447 # the history of the notmuch mailing list), which allows for reliably
448 # testing commands that need to operate on a not-totally-trivial
449 # number of messages.
450 add_email_corpus ()
451 {
452     rm -rf ${MAIL_DIR}
453     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
454         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
455     else
456         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
457         notmuch new >/dev/null
458         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
459     fi
460 }
461
462 test_begin_subtest ()
463 {
464     if [ -n "$inside_subtest" ]; then
465         exec 1>&6 2>&7          # Restore stdout and stderr
466         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
467     fi
468     test_subtest_name="$1"
469     test_reset_state_
470     # Remember stdout and stderr file descriptors and redirect test
471     # output to the previously prepared file descriptors 3 and 4 (see
472     # below)
473     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
474     exec 6>&1 7>&2 >&3 2>&4
475     inside_subtest=t
476 }
477
478 # Pass test if two arguments match
479 #
480 # Note: Unlike all other test_expect_* functions, this function does
481 # not accept a test name. Instead, the caller should call
482 # test_begin_subtest before calling this function in order to set the
483 # name.
484 test_expect_equal ()
485 {
486         exec 1>&6 2>&7          # Restore stdout and stderr
487         inside_subtest=
488         test "$#" = 3 && { prereq=$1; shift; } || prereq=
489         test "$#" = 2 ||
490         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
491
492         output="$1"
493         expected="$2"
494         if ! test_skip "$test_subtest_name"
495         then
496                 if [ "$output" = "$expected" ]; then
497                         test_ok_ "$test_subtest_name"
498                 else
499                         testname=$this_test.$test_count
500                         echo "$expected" > $testname.expected
501                         echo "$output" > $testname.output
502                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
503                 fi
504     fi
505 }
506
507 # Like test_expect_equal, but takes two filenames.
508 test_expect_equal_file ()
509 {
510         exec 1>&6 2>&7          # Restore stdout and stderr
511         inside_subtest=
512         test "$#" = 3 && { prereq=$1; shift; } || prereq=
513         test "$#" = 2 ||
514         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
515
516         file1="$1"
517         basename1=`basename "$file1"`
518         file2="$2"
519         basename2=`basename "$file2"`
520         if ! test_skip "$test_subtest_name"
521         then
522                 if diff -q "$file1" "$file2" >/dev/null ; then
523                         test_ok_ "$test_subtest_name"
524                 else
525                         testname=$this_test.$test_count
526                         cp "$file1" "$testname.$basename1"
527                         cp "$file2" "$testname.$basename2"
528                         test_failure_ "$test_subtest_name" "$(diff -u "$testname.$basename1" "$testname.$basename2")"
529                 fi
530     fi
531 }
532
533 # Like test_expect_equal, but arguments are JSON expressions to be
534 # canonicalized before diff'ing.  If an argument cannot be parsed, it
535 # is used unchanged so that there's something to diff against.
536 test_expect_equal_json () {
537     output=$(echo "$1" | python -mjson.tool || echo "$1")
538     expected=$(echo "$2" | python -mjson.tool || echo "$2")
539     shift 2
540     test_expect_equal "$output" "$expected" "$@"
541 }
542
543 test_emacs_expect_t () {
544         test "$#" = 2 && { prereq=$1; shift; } || prereq=
545         test "$#" = 1 ||
546         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
547
548         # Run the test.
549         if ! test_skip "$test_subtest_name"
550         then
551                 test_emacs "(notmuch-test-run $1)" >/dev/null
552
553                 # Restore state after the test.
554                 exec 1>&6 2>&7          # Restore stdout and stderr
555                 inside_subtest=
556
557                 # Report success/failure.
558                 result=$(cat OUTPUT)
559                 if [ "$result" = t ]
560                 then
561                         test_ok_ "$test_subtest_name"
562                 else
563                         test_failure_ "$test_subtest_name" "${result}"
564                 fi
565         else
566                 # Restore state after the (non) test.
567                 exec 1>&6 2>&7          # Restore stdout and stderr
568                 inside_subtest=
569         fi
570 }
571
572 NOTMUCH_NEW ()
573 {
574     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
575 }
576
577 notmuch_search_sanitize ()
578 {
579     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
580 }
581
582 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
583 notmuch_show_sanitize ()
584 {
585     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
586 }
587 notmuch_show_sanitize_all ()
588 {
589     sed \
590         -e 's| filename:.*| filename:XXXXX|' \
591         -e 's| id:[^ ]* | id:XXXXX |'
592 }
593
594 notmuch_json_show_sanitize ()
595 {
596     sed \
597         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
598         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|g'
599 }
600
601 # End of notmuch helper functions
602
603 # Use test_set_prereq to tell that a particular prerequisite is available.
604 # The prerequisite can later be checked for in two ways:
605 #
606 # - Explicitly using test_have_prereq.
607 #
608 # - Implicitly by specifying the prerequisite tag in the calls to
609 #   test_expect_{success,failure,code}.
610 #
611 # The single parameter is the prerequisite tag (a simple word, in all
612 # capital letters by convention).
613
614 test_set_prereq () {
615         satisfied="$satisfied$1 "
616 }
617 satisfied=" "
618
619 test_have_prereq () {
620         case $satisfied in
621         *" $1 "*)
622                 : yes, have it ;;
623         *)
624                 ! : nope ;;
625         esac
626 }
627
628 # declare prerequisite for the given external binary
629 test_declare_external_prereq () {
630         binary="$1"
631         test "$#" = 2 && name=$2 || name="$binary(1)"
632
633         hash $binary 2>/dev/null || eval "
634         test_missing_external_prereq_${binary}_=t
635 $binary () {
636         echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
637         test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
638         false
639 }"
640 }
641
642 # Explicitly require external prerequisite.  Useful when binary is
643 # called indirectly (e.g. from emacs).
644 # Returns success if dependency is available, failure otherwise.
645 test_require_external_prereq () {
646         binary="$1"
647         if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
648                 # dependency is missing, call the replacement function to note it
649                 eval "$binary"
650         else
651                 true
652         fi
653 }
654
655 # You are not expected to call test_ok_ and test_failure_ directly, use
656 # the text_expect_* functions instead.
657
658 test_ok_ () {
659         if test "$test_subtest_known_broken_" = "t"; then
660                 test_known_broken_ok_ "$@"
661                 return
662         fi
663         test_success=$(($test_success + 1))
664         say_color pass "%-6s" "PASS"
665         echo " $@"
666 }
667
668 test_failure_ () {
669         if test "$test_subtest_known_broken_" = "t"; then
670                 test_known_broken_failure_ "$@"
671                 return
672         fi
673         test_failure=$(($test_failure + 1))
674         test_failure_message_ "FAIL" "$@"
675         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
676         return 1
677 }
678
679 test_failure_message_ () {
680         say_color error "%-6s" "$1"
681         echo " $2"
682         shift 2
683         echo "$@" | sed -e 's/^/        /'
684         if test "$verbose" != "t"; then cat test.output; fi
685 }
686
687 test_known_broken_ok_ () {
688         test_reset_state_
689         test_fixed=$(($test_fixed+1))
690         say_color pass "%-6s" "FIXED"
691         echo " $@"
692 }
693
694 test_known_broken_failure_ () {
695         test_reset_state_
696         test_broken=$(($test_broken+1))
697         test_failure_message_ "BROKEN" "$@"
698         return 1
699 }
700
701 test_debug () {
702         test "$debug" = "" || eval "$1"
703 }
704
705 test_run_ () {
706         test_cleanup=:
707         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
708         eval >&3 2>&4 "$1"
709         eval_ret=$?
710         eval >&3 2>&4 "$test_cleanup"
711         return 0
712 }
713
714 test_skip () {
715         test_count=$(($test_count+1))
716         to_skip=
717         for skp in $NOTMUCH_SKIP_TESTS
718         do
719                 case $this_test.$test_count in
720                 $skp)
721                         to_skip=t
722                 esac
723         done
724         if test -z "$to_skip" && test -n "$prereq" &&
725            ! test_have_prereq "$prereq"
726         then
727                 to_skip=t
728         fi
729         case "$to_skip" in
730         t)
731                 test_report_skip_ "$@"
732                 ;;
733         *)
734                 test_check_missing_external_prereqs_ "$@"
735                 ;;
736         esac
737 }
738
739 test_check_missing_external_prereqs_ () {
740         if test -n "$test_subtest_missing_external_prereqs_"; then
741                 say_color skip >&1 "missing prerequisites:"
742                 echo "$test_subtest_missing_external_prereqs_" >&1
743                 test_report_skip_ "$@"
744         else
745                 false
746         fi
747 }
748
749 test_report_skip_ () {
750         test_reset_state_
751         say_color skip >&3 "skipping test:"
752         echo " $@" >&3
753         say_color skip "%-6s" "SKIP"
754         echo " $1"
755 }
756
757 test_subtest_known_broken () {
758         test_subtest_known_broken_=t
759 }
760
761 test_expect_success () {
762         test "$#" = 3 && { prereq=$1; shift; } || prereq=
763         test "$#" = 2 ||
764         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
765         test_reset_state_
766         if ! test_skip "$@"
767         then
768                 test_run_ "$2"
769                 run_ret="$?"
770                 # test_run_ may update missing external prerequisites
771                 test_check_missing_external_prereqs_ "$@" ||
772                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
773                 then
774                         test_ok_ "$1"
775                 else
776                         test_failure_ "$@"
777                 fi
778         fi
779 }
780
781 test_expect_code () {
782         test "$#" = 4 && { prereq=$1; shift; } || prereq=
783         test "$#" = 3 ||
784         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
785         test_reset_state_
786         if ! test_skip "$@"
787         then
788                 test_run_ "$3"
789                 run_ret="$?"
790                 # test_run_ may update missing external prerequisites,
791                 test_check_missing_external_prereqs_ "$@" ||
792                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
793                 then
794                         test_ok_ "$2"
795                 else
796                         test_failure_ "$@"
797                 fi
798         fi
799 }
800
801 # test_external runs external test scripts that provide continuous
802 # test output about their progress, and succeeds/fails on
803 # zero/non-zero exit code.  It outputs the test output on stdout even
804 # in non-verbose mode, and announces the external script with "* run
805 # <n>: ..." before running it.  When providing relative paths, keep in
806 # mind that all scripts run in "trash directory".
807 # Usage: test_external description command arguments...
808 # Example: test_external 'Perl API' perl ../path/to/test.pl
809 test_external () {
810         test "$#" = 4 && { prereq=$1; shift; } || prereq=
811         test "$#" = 3 ||
812         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
813         descr="$1"
814         shift
815         test_reset_state_
816         if ! test_skip "$descr" "$@"
817         then
818                 # Announce the script to reduce confusion about the
819                 # test output that follows.
820                 say_color "" " run $test_count: $descr ($*)"
821                 # Run command; redirect its stderr to &4 as in
822                 # test_run_, but keep its stdout on our stdout even in
823                 # non-verbose mode.
824                 "$@" 2>&4
825                 if [ "$?" = 0 ]
826                 then
827                         test_ok_ "$descr"
828                 else
829                         test_failure_ "$descr" "$@"
830                 fi
831         fi
832 }
833
834 # Like test_external, but in addition tests that the command generated
835 # no output on stderr.
836 test_external_without_stderr () {
837         # The temporary file has no (and must have no) security
838         # implications.
839         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
840         stderr="$tmp/git-external-stderr.$$.tmp"
841         test_external "$@" 4> "$stderr"
842         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
843         descr="no stderr: $1"
844         shift
845         if [ ! -s "$stderr" ]; then
846                 rm "$stderr"
847                 test_ok_ "$descr"
848         else
849                 if [ "$verbose" = t ]; then
850                         output=`echo; echo Stderr is:; cat "$stderr"`
851                 else
852                         output=
853                 fi
854                 # rm first in case test_failure exits.
855                 rm "$stderr"
856                 test_failure_ "$descr" "$@" "$output"
857         fi
858 }
859
860 # This is not among top-level (test_expect_success)
861 # but is a prefix that can be used in the test script, like:
862 #
863 #       test_expect_success 'complain and die' '
864 #           do something &&
865 #           do something else &&
866 #           test_must_fail git checkout ../outerspace
867 #       '
868 #
869 # Writing this as "! git checkout ../outerspace" is wrong, because
870 # the failure could be due to a segv.  We want a controlled failure.
871
872 test_must_fail () {
873         "$@"
874         test $? -gt 0 -a $? -le 129 -o $? -gt 192
875 }
876
877 # test_cmp is a helper function to compare actual and expected output.
878 # You can use it like:
879 #
880 #       test_expect_success 'foo works' '
881 #               echo expected >expected &&
882 #               foo >actual &&
883 #               test_cmp expected actual
884 #       '
885 #
886 # This could be written as either "cmp" or "diff -u", but:
887 # - cmp's output is not nearly as easy to read as diff -u
888 # - not all diff versions understand "-u"
889
890 test_cmp() {
891         $GIT_TEST_CMP "$@"
892 }
893
894 # This function can be used to schedule some commands to be run
895 # unconditionally at the end of the test to restore sanity:
896 #
897 #       test_expect_success 'test core.capslock' '
898 #               git config core.capslock true &&
899 #               test_when_finished "git config --unset core.capslock" &&
900 #               hello world
901 #       '
902 #
903 # That would be roughly equivalent to
904 #
905 #       test_expect_success 'test core.capslock' '
906 #               git config core.capslock true &&
907 #               hello world
908 #               git config --unset core.capslock
909 #       '
910 #
911 # except that the greeting and config --unset must both succeed for
912 # the test to pass.
913
914 test_when_finished () {
915         test_cleanup="{ $*
916                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
917 }
918
919 test_done () {
920         GIT_EXIT_OK=t
921         test_results_dir="$TEST_DIRECTORY/test-results"
922         mkdir -p "$test_results_dir"
923         test_results_path="$test_results_dir/${0%.sh}-$$"
924
925         echo "total $test_count" >> $test_results_path
926         echo "success $test_success" >> $test_results_path
927         echo "fixed $test_fixed" >> $test_results_path
928         echo "broken $test_broken" >> $test_results_path
929         echo "failed $test_failure" >> $test_results_path
930         echo "" >> $test_results_path
931
932         echo
933
934         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
935
936         if [ "$test_failure" = "0" ]; then
937             if [ "$test_broken" = "0" ]; then
938                 rm -rf "$remove_tmp"
939             fi
940             exit 0
941         else
942             exit 1
943         fi
944 }
945
946 emacs_generate_script () {
947         # Construct a little test script here for the benefit of the user,
948         # (who can easily run "run_emacs" to get the same emacs environment
949         # for investigating any failures).
950         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
951 #!/bin/sh
952 export PATH=$PATH
953 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
954
955 # Here's what we are using here:
956 #
957 # --no-init-file        Don't load users ~/.emacs
958 #
959 # --no-site-file        Don't load the site-wide startup stuff
960 #
961 # --directory           Ensure that the local elisp sources are found
962 #
963 # --load                Force loading of notmuch.el and test-lib.el
964
965 exec ${TEST_EMACS} --no-init-file --no-site-file \
966         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
967         --directory "$TEST_DIRECTORY" --load test-lib.el \
968         "\$@"
969 EOF
970         chmod a+x "$TMP_DIRECTORY/run_emacs"
971 }
972
973 test_emacs () {
974         # test dependencies beforehand to avoid the waiting loop below
975         missing_dependencies=
976         test_require_external_prereq dtach || missing_dependencies=1
977         test_require_external_prereq emacs || missing_dependencies=1
978         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
979         test -z "$missing_dependencies" || return
980
981         if [ -z "$EMACS_SERVER" ]; then
982                 emacs_tests="$(basename $0).el"
983                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
984                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
985                 else
986                         load_emacs_tests=
987                 fi
988                 server_name="notmuch-test-suite-$$"
989                 # start a detached session with an emacs server
990                 # user's TERM is given to dtach which assumes a minimally
991                 # VT100-compatible terminal -- and emacs inherits that
992                 TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
993                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
994                                 --no-window-system \
995                                 $load_emacs_tests \
996                                 --eval '(setq server-name \"$server_name\")' \
997                                 --eval '(server-start)' \
998                                 --eval '(orphan-watchdog $$)'" || return
999                 EMACS_SERVER="$server_name"
1000                 # wait until the emacs server is up
1001                 until test_emacs '()' >/dev/null 2>/dev/null; do
1002                         sleep 1
1003                 done
1004         fi
1005
1006         # Clear test-output output file.  Most Emacs tests end with a
1007         # call to (test-output).  If the test code fails with an
1008         # exception before this call, the output file won't get
1009         # updated.  Since we don't want to compare against an output
1010         # file from another test, so start out with an empty file.
1011         rm -f OUTPUT
1012         touch OUTPUT
1013
1014         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(progn $@)"
1015 }
1016
1017 test_python() {
1018         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1019         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1020
1021         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1022         # most others as /usr/bin/python. So first try python2, and fallback to
1023         # python if python2 doesn't exist.
1024         cmd=python2
1025         [[ "$test_missing_external_prereq_python2_" = t ]] && cmd=python
1026
1027         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1028                 | $cmd -
1029 }
1030
1031 # Creates a script that counts how much time it is executed and calls
1032 # notmuch.  $notmuch_counter_command is set to the path to the
1033 # generated script.  Use notmuch_counter_value() function to get the
1034 # current counter value.
1035 notmuch_counter_reset () {
1036         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1037         if [ ! -x "$notmuch_counter_command" ]; then
1038                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1039                 cat >"$notmuch_counter_command" <<EOF || return
1040 #!/bin/sh
1041
1042 read count < "$notmuch_counter_state_path"
1043 echo \$((count + 1)) > "$notmuch_counter_state_path"
1044
1045 exec notmuch "\$@"
1046 EOF
1047                 chmod +x "$notmuch_counter_command" || return
1048         fi
1049
1050         echo 0 > "$notmuch_counter_state_path"
1051 }
1052
1053 # Returns the current notmuch counter value.
1054 notmuch_counter_value () {
1055         if [ -r "$notmuch_counter_state_path" ]; then
1056                 read count < "$notmuch_counter_state_path"
1057         else
1058                 count=0
1059         fi
1060         echo $count
1061 }
1062
1063 test_reset_state_ () {
1064         test -z "$test_init_done_" && test_init_
1065
1066         test_subtest_known_broken_=
1067         test_subtest_missing_external_prereqs_=
1068 }
1069
1070 # called once before the first subtest
1071 test_init_ () {
1072         test_init_done_=t
1073
1074         # skip all tests if there were external prerequisites missing during init
1075         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1076 }
1077
1078
1079 . ./test-lib-common.sh
1080
1081 emacs_generate_script
1082
1083
1084 # Use -P to resolve symlinks in our working directory so that the cwd
1085 # in subprocesses like git equals our $PWD (for pathname comparisons).
1086 cd -P "$test" || error "Cannot setup test environment"
1087
1088 if test "$verbose" = "t"
1089 then
1090         exec 4>&2 3>&1
1091 else
1092         exec 4>test.output 3>&4
1093 fi
1094
1095 this_test=${0##*/}
1096 for skp in $NOTMUCH_SKIP_TESTS
1097 do
1098         to_skip=
1099         for skp in $NOTMUCH_SKIP_TESTS
1100         do
1101                 case "$this_test" in
1102                 $skp)
1103                         to_skip=t
1104                 esac
1105         done
1106         case "$to_skip" in
1107         t)
1108                 say_color skip >&3 "skipping test $this_test altogether"
1109                 say_color skip "skip all tests in $this_test"
1110                 test_done
1111         esac
1112 done
1113
1114 # Provide an implementation of the 'yes' utility
1115 yes () {
1116         if test $# = 0
1117         then
1118                 y=y
1119         else
1120                 y="$*"
1121         fi
1122
1123         while echo "$y"
1124         do
1125                 :
1126         done
1127 }
1128
1129 # Fix some commands on Windows
1130 case $(uname -s) in
1131 *MINGW*)
1132         # Windows has its own (incompatible) sort and find
1133         sort () {
1134                 /usr/bin/sort "$@"
1135         }
1136         find () {
1137                 /usr/bin/find "$@"
1138         }
1139         sum () {
1140                 md5sum "$@"
1141         }
1142         # git sees Windows-style pwd
1143         pwd () {
1144                 builtin pwd -W
1145         }
1146         # no POSIX permissions
1147         # backslashes in pathspec are converted to '/'
1148         # exec does not inherit the PID
1149         ;;
1150 *)
1151         test_set_prereq POSIXPERM
1152         test_set_prereq BSLASHPSPEC
1153         test_set_prereq EXECKEEPSPID
1154         ;;
1155 esac
1156
1157 test -z "$NO_PERL" && test_set_prereq PERL
1158 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1159
1160 # test whether the filesystem supports symbolic links
1161 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1162 rm -f y
1163
1164 # declare prerequisites for external binaries used in tests
1165 test_declare_external_prereq dtach
1166 test_declare_external_prereq emacs
1167 test_declare_external_prereq ${TEST_EMACSCLIENT}
1168 test_declare_external_prereq gdb
1169 test_declare_external_prereq gpg
1170 test_declare_external_prereq python
1171 test_declare_external_prereq python2